/*
test the raggedstone1 design jf@pibf.de
*/

#include <stdio.h>
#include <fcntl.h>      /* open */ 
#include <unistd.h>     /* exit */
#include <sys/ioctl.h>  /* ioctl */
#include <netinet/in.h>
#include <stdlib.h>

#define MAJOR_NUM 249
#define IOCTL_SET7SEG _IOR(MAJOR_NUM, 0, short int)
#define IOCTL_GET7SEG _IOW(MAJOR_NUM, 1, short int)
#define IOCTL_SETLED _IOR(MAJOR_NUM, 2, short int)
#define DEVICE_NAME "/dev/rs1"


//---------------------------------------------------------------------------------
ioctl_set7seg(int file_desc, short int data)
	{
	int ret_val;
	data = htons(data);
	//printf("data:0x%x\n");
	ret_val = ioctl(file_desc, IOCTL_SET7SEG, data);
	if (ret_val < 0) 
		{
		printf ("ioctl_set_msg failed:%d\n", ret_val);
		exit(-1);
		}
	}

//---------------------------------------------------------------------------------
int ioctl_get7seg(int file_desc)
	{
	int ret_val=0;
	int lesen_led=0;
	//data = htons(data);
	//printf("data:0x%x\n");
	ret_val = ioctl(file_desc, IOCTL_GET7SEG, &lesen_led);

	if (ret_val < 0) 
		{
		printf ("ioctl_set_msg failed:%d\n", ret_val);
		exit(-1);
		}
	return(lesen_led);
	}

//---------------------------------------------------------------------------------
ioctl_setled(int file_desc, short int data)
	{
	int ret_val;
	data = htons(data);
	//printf("data:0x%x\n");
	ret_val = ioctl(file_desc, IOCTL_SETLED, data);
	if (ret_val < 0) 
		{
		printf ("ioctl_set_msg failed:%d\n", ret_val);
		exit(-1);
		}
	}

/*---------------------------------------------------------------------------------*/
int main(int argc, char ** argv)
	{
	int file_desc, ret_val, i;
	char *msg = "Message passed by ioctl\n";
	short int val = 0;

	file_desc = open(DEVICE_NAME, 0);
	if (file_desc < 0) 
		{
		printf ("Can't open device file: %s\n", DEVICE_NAME);
		exit(-1);
		}
	
	while (1)
		{
		printf("Zahl:%d\n",val);
		ioctl_set7seg(file_desc, val);
		i=ioctl_get7seg(file_desc); 
		ioctl_setled(file_desc, val);
		printf("lesen:%d\n",ntohs(i)); //htons(data)
		val++;
		usleep(40000);
		}
	close(file_desc); 
	}

